#include <stdio.h>
#include <stdlib.h>
#include <curses.h>
#include <iostream.h>
#include <panel.h>
#include <string.h>
#include <ctype.h>


#define CNTRL_O 15
#define CNTRL_N 14 
#define CNTRL_S 19
#define CNTRL_W 23
#define CNTRL_Y 25

class node
{
	public :
		int data,row,col;

		node *next,*prev,*up,*down;
	
		node()
		{
			row = 1;
			col = 0;
			next = prev = up = down = NULL;
		}
};	

class list
{
	private :
		node *head,*last,*end;

	public :
		list()
		{
			head = last = end = NULL;
		}
		
		void enter();
		node* crow();
		void alpha(int c);
		void alins(int c);
		void ins_word(WINDOW *);
		void ins_line(WINDOW *);
		void line_in(WINDOW *);
		void word_in(WINDOW *);
		
		void init();
		WINDOW * init_main(WINDOW * main);
		void main_win(WINDOW *main);
		void inwin(WINDOW *win);
		void ref_sub(WINDOW *);
		
		void forcolor(WINDOW *);
		void backcolor(WINDOW *);
		void open_win(WINDOW *);
		void open_help(WINDOW *);
		int help_menu(WINDOW *,int);
		int open_file(WINDOW *,int);
		int open_edit(WINDOW *);
		int open_page(WINDOW *);
		void del_file(WINDOW *);
		void open_about(WINDOW *);
		
		int checkc(int);
		node* find(int,int);
		
		void disp(WINDOW *win);
		
		void fsave(WINDOW *);
		void nsave(WINDOW *);
		void leftm(WINDOW *);
		void rightm(WINDOW *);
		void topm(WINDOW *);
		void botm(WINDOW *);

		void arrow_up();
		void arrow_down();
		void arrow_right();
		void arrow_left();
		void upa();
		void dwna();
		void home();
		void enda(); 
		
		void back();
		void d_word();
		void d_char();
		void delc(int,int);
		void dell();
		void d_lin();
		void delw();
		void ad_delc(int,int,int);
		void d_tab(node *);
		void b_tab(node *);

		void begin();
		void endp();
		
		WINDOW* mainc(WINDOW *);
		void blockwin(WINDOW *,char st[20][50],int,int);
};

int ins = 1, save = 1, tab = 5;
int lm = 0, rm = 0, tm = 0, bm = 0;
int x = 0, x1 = 0, k = 1, y = 1,z = 0;
int colour[] = {0,1,2,3,4,5,6,7}, fore = 7, bac = 4;

char name[50] = "noname";

void list :: enter()
{
	save = 0;
	node *p,*q,*r,*s,*t;
	int i,j;
		
	p = new node;
	p -> data = '\n';
	p -> row = k;
	p -> col = x1;

	for (q = head;q != NULL && q -> row != k;q = q -> down);
	for (r = q;r != NULL && r -> col != x1 - 1;r = r -> next);
	last = r;
	
	if(last != NULL)	r = last -> next;
	p -> next = NULL;
	if (last != NULL)	last -> next = p;
	p -> prev = last;
	
	s = crow();
	s -> next = r;
	if (r != NULL) r -> prev = s;
	x1 = 1;

	for (t = s -> next;t != NULL;t = t -> next)
	{
	    t -> col = x1++;
	    t -> row = k + 1;
	}
}

node* list :: crow()
{
	node *p,*q,*r;
	p = new node;
	p -> row = k + 1;
	
	for (q = head;q != NULL && q -> row != k;q = q -> down);
	
	if (q -> down == NULL)
	{
	    end -> down = p;
	    p -> up = end;
	    end = p;
	}
	else
	{
	    r = q -> down;
	    p -> up = q; 
	    p -> down = r;
	    if (r != NULL)	r -> up = p;
	    q -> down = p;
	}
		    
	for (q = p -> down;q != NULL;q = q -> down)
	    for (r = q;r != NULL;r = r -> next)
		r -> row++;
	return p;
}

void list :: alpha(int c)
{
	save = 0;
	node *p,*q,*r;
	
	p = new node;
	p -> row = k;
	p -> col = x1;
	p -> data = c;
	
	for (q = head;q != NULL && q -> row != k;q = q -> down);
	for (r = q;r != NULL && r -> col != x1 - 1;r = r -> next);
	last = r;

	if(last != NULL)	r = last -> next;
	p -> next = r;
	p -> prev = last;
	if (r != NULL)	r -> prev = p;
	if(last != NULL)	last -> next = p;

	for (q = p -> next;q != NULL;q = q -> next)	
	    q -> col++;

	x1++;
}

void list :: init()
{
	head = new node;
	end = head;
	last = head;
}

void list :: disp(WINDOW *win)
{
    node *p,*q,*r,*t;
    int i,j,flag = 0,d,e,n = z;
    int l = 1,m = lm + 1;
    
    werase(win);
    p = head;
    e = 0;
    
    while(1)
    {
	if (n == 0) break;
	e = checkc(p -> row);
	i = (e % (78 - rm - lm));
	e = e / (78 - rm - lm);
	e++;
	if (i == 0)	e--;
	q = p;
	
	if (e <= n)
	{
	    n = n - e;
	    p = p -> down;
	}
	else
	{
	    for (d = 0;d < ((78 - lm - rm) * (n));d++)	p = p -> next;
	    flag = 1;
	    break;
	}
    }

    l = tm + 1;
    m = 1;
    i = tm + 1;
	
    for (r = p;r != NULL;r = r -> down)
    {
        m = lm + 1;
        for (t = r -> next;t != NULL;t = t -> next)
        {
	    if (m == 79 - rm)	
	    {
	        m = lm + 1;
	        l++;
	        i++;
	        if (i >= 22 - bm)	return;
	    }
	    wmove(win,l,m++);
	    if(t -> data == '\v')	waddch(win,' ');
	    else waddch(win,t -> data);
	}

        if (flag == 1)	
        {
	    r = q;
	    flag = 0;
	}
	l++;
	i++;
	if (i >= 22 - bm)	break;
    }
}	

int list :: checkc(int a)
{
    node *p,*q;
    for (p = head;p -> row != a;p = p -> down);
    if (p -> next == NULL)	return(0);
    for (q = p -> next;q -> next != NULL;q = q -> next);
    return(q -> col);
}

void list :: alins(int c)
{
	save = 0;
	node *p,*q,*r;
	
	for (q = head;q != NULL && q -> row != k;q = q -> down);
	for (r = q;r != NULL && r -> col != x1;r = r -> next);
	
	r -> data = c;
	x1++;
}

node *list :: find(int a,int b)
{
    node *p,*q,*r;
    
    for(p = head;p != NULL && p -> row != a;p = p -> down);
    for(q = p;q != NULL && q -> col != b;q = q -> next);
    if (q != NULL)	return q;
    return NULL;
}

void list :: d_tab(node *p)
{
    save = 0;
    int i;
    node *q,*r;
    r = p -> prev;
    
    for (i = 0;i <= 4;i++)	p = p -> next;
    for (q = p;q != NULL;q = q -> next)	q -> col -= 5;
        
    if (r != NULL)	r -> next = p;
    if (p != NULL)	p -> prev = r;
}
        
void list :: b_tab(node *p)
{
    save = 0;
    int i;
    node *q,*r;
    r = p -> next;
    
    for (i = 0;i <= 4;i++)	p = p -> prev;
    
    for (q = r;q != NULL;q = q -> next)	q -> col -= 5;
    
    if (r != NULL)	r -> prev = p;
    if (p != NULL)	p -> next = r;
}

void list :: delw()
{
    node *p,*q,*r;
    int i;
    
    p = find(k,x1);
    if (p == NULL)
    {
	x1--;
	p = find(k,x1);
	x--;
    }
    
    if (p -> data == '\t')
    {
	d_tab(p);
	return;
    }
    r = p;
    
    while(p -> data != ' ' && p -> col != 0 && p -> prev -> data != '\t')  p = p -> prev;
    
    if (r != NULL && r -> next != NULL){
    while(r -> data != ' ' && r -> next -> data != '\n' && r -> next -> data != '\t' && r != NULL)
    {
        r = r -> next;
	if (r == NULL || r -> next == NULL)	break;
    }}
    
    if (r != NULL) q = r -> next;
    
    p -> next = q;
    if (q != NULL)	q -> prev = p;
    
    i = p -> col;
    for (r = p -> next;r != NULL;r = r -> next)		r -> col = ++i;
    
    i = checkc(k);
    if (i == 0) i = 1;
    while (x1 > i)
    {
	x1--;
	x--;
	if (x <= lm)	
	{
	    x = 78 - rm;
	    y--;
	    if(y <= tm)
	    {
		y = tm + 1;
		z--;
	    }
	}
    }
}

void list :: back()
{
    save = 0;
    node *p;
    if (x1 == 1)
    {
	if (k != 1)
	{
	    x = checkc(k - 1);
	    x1 = x;
	    while (x > (78 - rm - lm)) x -= (78 - lm - rm);
    	    x = x + lm;			    
	    ad_delc(k - 1,y,checkc(k - 1));
	    k--;
	    y--;
	    if (y == tm)
	    {
		z--;
		y = tm + 1;
	    }
	}
	else beep();
    }
    else 
    {
	p = find(k,x1 - 1);
	if (p -> data == '\v')	
	{
	    b_tab(p);
	    for (int i = 0;i < 5;i++)
	    {
	    x --;
	    if (x <= lm)	
	    {
		x = 78 - rm - lm + x;
		y--;
		if (y == tm)	
		{
		    y++;
		    z--;
		}
	    }
	    x1 --;
	}
	}
	else
	{
	    delc(k,x1 - 1);
	    
	    x1--;
	    if (x != lm + 1)	x--;
	    else
	    {
		x = 78 - rm;
		y--;
		if (y == tm)
		{
		    y++;
		    z--;
		}
	    }
	}
    }
}	    

void list :: d_word()
{
    node *p;
    if (head -> next == NULL)	beep();
    else
    {
	save = 0;
	p = find(k,x1);
	if (x1 == checkc(k) && p -> data == '\n')    ad_delc(k,y,x1);
	else
	{
	    save = 0;
	    delw();
	}
    }
}			

void list :: d_char()
{
    save = 0;
    node *p;
    if (x1 >= checkc(k))
    {
	if (k != end -> row && x1 == checkc(k))
	    ad_delc(k,y,x1);
	else beep();
    }
    else
    {
	p = find(k,x1);
	if (p -> data == '\t')	d_tab(p);
	else
	    delc(k,x1);
    }
}

void list :: ins_word(WINDOW *main)
{
    save = 0;
    curs_set(1);
    ins = 1;
    
    char ch[100],c;
    WINDOW *ws;
    
    ws = subwin(main,3,80,22,0);
    werase(ws);
    init_pair(5,COLOR_BLACK,COLOR_WHITE);
    wbkgd(ws,COLOR_PAIR(5));
    wrefresh(ws);
    
    waddstr(ws,"Enter the word to be inserted : ");
    mvwprintw(ws,1,1,"-");
    echo();
    mvwgetstr(ws,1,2,ch);
    noecho();
    
    for (int i = 0;i < strlen(ch);i++)
    {
	alpha(ch[i]);
	x++;
	if (x > 78 - rm)
	{
	    y++;
	    if (y == 22 - bm)
	    {
	        z++;
	        y = 21 - bm;
	    }
	    x = lm + 1;
	}	    
    }
}

void list :: ins_line(WINDOW *main)
{
    save = 0;
    curs_set(1);
    ins = 1;
    
    char ch[100],c;
    WINDOW *ws;
    
    ws = subwin(main,3,80,22,0);
    werase(ws);
    init_pair(5,COLOR_BLACK,COLOR_WHITE);
    wbkgd(ws,COLOR_PAIR(5));
    wrefresh(ws);
    
    waddstr(ws,"Enter the line to be inserted : ");
    mvwprintw(ws,1,1,"-");
    echo();
    mvwgetstr(ws,1,2,ch);
    noecho();
    
    for (int i = 0;i < strlen(ch);i++)
    {
	alpha(ch[i]);
	x++;
	if (x > 78 - rm)
	{
	    y++;
	    if (y == 22 - bm)
	    {
	        z++;
	        y = 21 - bm;
	    }
	    x = lm + 1;
	}	    
    }
}

void list :: line_in(WINDOW *main)
{
    
}

void list :: word_in(WINDOW *main)
{
    
}

void list :: inwin(WINDOW *main)
{
	WINDOW *win,*sub;
	FILE *fp;
	node *p,*q,*r;
	int c,i,a,b,flag = 0;
	y = tm + 1,x = lm + 1,z = 0,k = 1,x1 = 1;
	char cl[] = "clear";
	
	init();
	curs_set(1);
        win = mainc(main);
	werase(win);
	box(win,0,0);
	
	sub = subwin(main,1,80,24,0);
	ref_sub(sub);

	fp = fopen(name,"r+");
	if (fp == NULL)	fp = fopen(name,"w+");
	
	while((c = getc(fp)) != EOF)
	{
		save = 1;
		wmove(win,k,x1);
		if (k == 21)
		{
			disp(win);		
			box(win,0,0);
		}

		switch(c)
		{
			case '\t':
				alpha(c);
				for (i = 0;i < tab - 1;i++)
					alpha('\v');
				break;

			case (KEY_ENTER) :
			case 10:
				enter();
				k++;
				break;

			default :	
				alpha(c);
		}			
	}
	disp(win);
	box(win,0,0);
	wrefresh(win);

	fclose(fp);
	save = 1;
	keypad(win,TRUE);
	wrefresh(win);
	x1 = k = 1;
	x = lm + 1;
	y = tm + 1;
	
	while(1)
	{
		box(win,0,0);
		wmove(win,y,x);		
		wrefresh(win);
		c = wgetch(win);
			
		switch(c)
		{
			case 27 :
			    c = wgetch(win);
			    
			    switch(c)
			    {
				case 'f' : 
				    i = open_file(main,1);
				    while(1)
				    {
					main = init_main(main);
					win = mainc(main);
					disp(win);
					ref_sub(sub);
					box(win,0,0);
					wrefresh(win);
					if(i == 0)	break;
					else if(i == 1)	i = open_file(main,1);
					else if(i == 2)	i = open_edit(main);
					else if(i == 3)	i = open_page(main);
					else if(i == 4)	i = help_menu(main,1);
				    }
				    break;
				    
				case 'e' :
				    i = open_edit(main);
				    while(1)
				    {

					main = init_main(main);
					win = mainc(main);
					disp(win);
					ref_sub(sub);
					box(win,0,0);
					wrefresh(win);
										main = init_main(main);
					if(i == 0)	break;
					else if(i == 1)	i = open_file(main,1);
					else if(i == 2)	i = open_edit(main);
					else if(i == 3)	i = open_page(main);
					else if(i == 4)	i = help_menu(main,1);
				    }
				    break;
				    
				case 'p' :
				    i = open_page(main);
				    while(1)
				    {
					main = init_main(main);
					win = mainc(main);
					disp(win);
					ref_sub(sub);
					box(win,0,0);
					wrefresh(win);
						
					if(i == 0)	break;
					else if(i == 1)	i = open_file(main,1);
					else if(i == 2)	i = open_edit(main);
					else if(i == 3)	i = open_page(main);
					else if(i == 4)	i = help_menu(main,1);
				    }
				    break;
				    
				case 'h' :
				    i = help_menu(main,1);
				    while(1)
				    {
					main = init_main(main);
					win = mainc(main);
					disp(win);
					ref_sub(sub);
					box(win,0,0);
					wrefresh(win);
					
					if(i == 0)	break;
					else if(i == 1)	i = open_file(main,1);
					else if(i == 2)	i = open_edit(main);
					else if(i == 3)	i = open_page(main);
					else if(i == 4)	i = help_menu(main,1);
				    }
				    break;
				    
				case 'x' :
				    if(save == 0)	
					nsave(main);				    
				        
				    wrefresh(win);
				    system(cl);
				    endwin();
				    exit(0);
			    }
			    break;
			    
			case (KEY_UP) :
			    if (k == 1 && x1 < 78 - lm - rm) beep();
			    else
				arrow_up();		
			    break;
			    
			case (KEY_DOWN) :
			    i = checkc(k);
			    i = i - x1;
			    if (k == end -> row && (x + i <= 78 - rm)) beep();
			    else 
				arrow_down();
			    break;
			    
			case (KEY_LEFT) :
			    if (x1 == 1 && k == 1)	beep();
			    else 
				arrow_left();
			    break;
			           
			   
			case (KEY_RIGHT) :
			    arrow_right();
				break;
			   			
			case 10:
			case (KEY_ENTER):
			    save = 0;
			    enter();
			    
			    if (y == 21 - bm)
				z++;
			    else y++;

			    k++;			    
			    x = lm + 1;
			    x1 = 1;
			    break;
			    
			case (KEY_F(1)) :
			    open_help(main);
			    break;
			    
			case (KEY_F(2)) :
			    save = 1;
			    fsave(main);
			    break;

			case (KEY_F(3)) :
			    if(save == 0)
				nsave(main);
			    open_win(main);
			    break;
			    
			case (KEY_F(4)) :
			    if(save == 0)
				nsave(main);
				
			    strcpy(name,"noname");
			    main_win(main);
			    break;
			    
			case (KEY_F(5)) :
			    del_file(main);
			    break;
			    
			case (KEY_F(7)) :
			    forcolor(win);
			    break;

			case (KEY_F(8)) :
			    backcolor(win);
			    break;
			
						
			case (KEY_F(9)) :
			    leftm(main);
			    break;
			    

			case (KEY_F(10)) :
			    rightm(main);
			    break;
			    
			case (KEY_F(11)) :
			    topm(main);
			    break;

			case (KEY_F(12)) :
			    botm(main);
			    break;
	
			    
			case 2 :
			    begin();
			    break;

			case 5 :
			    endp();
			    break;
			    
			case (KEY_DC) :
			    save = 0;
			    d_char();
			    break;

			case (KEY_BACKSPACE) :
			    save = 0;
			    back();    
			    break;
			    			    
			case 25 :
			    d_lin();
			    break;

			case 23 :
			    save = 0;
			    d_word();
			    break;
			
			case (KEY_NPAGE) :
			    if (k == end -> row)	beep();
			    else
			    {
				for (i = 0;i < 21 - bm;i++)
				{
				    arrow_down();
				    if (k == end -> row)	
				    {
					int j = checkc(k);
					while(1)
					{
					    i = j - x1;
					    if (x + i <= 78 - rm ) break;
					    arrow_right();
					}
					break;
				    }
				}
			    }
			    break;

			case (KEY_PPAGE) :
			    if (k == 1)	beep();
			    else
			    {
				    for (i = 0;i < 21 - bm;i++)
				    {
					arrow_up();
					if (k == 1)	
					{
					    while(1)
					    {
						if (x1 <= 78 - rm - lm) break;
						arrow_left();
				    	    }
					    break;
					}
				    }
			    }
			    break;
			    
			case (KEY_IC):
			    ins = (ins ? 0 : 1);
			    if (ins == 1)	curs_set(1);
			    if (ins == 0)	curs_set(2);
			    break;

			case (KEY_HOME) :
			    home();
			    break;
			    
			case (KEY_END) :
			    enda();	
			    break;
			    
			case 14 :
			    if (save == 0)
				nsave(win);
			     
			    strcpy(name,"noname");
			    inwin(win);
			    break;
			    	
			case 1:
			    word_in(main);
			    break;
			
			case 12 :
			    line_in(main);
			    break;
			    			    
			case '\t':
				save = 0;
				alpha(c);
				x++;
				if (x > 78 - rm)
				{
				    y++;
				    if (y == 22 - bm)
				    {
					z++;
					y = 21 - bm;
				    }
				    x = lm + 1;
				}	    
				for (i = 0;i < tab - 1;i++)
				{
					alpha('\v');
					x++;
					if (x > 78 - rm)
					{
					    y++;
					    if (y == 22 - bm)
					    {
						z++;
						y = 21 - bm;
					    }
					    x = lm + 1;
					}	    
				}
				break;

			default :
			    save = 0;
			    
			    if(ins == 1)
				alpha(c);
			    else
			    {
				if (x1 <= checkc(k))
				    alins(c);		
				else alpha(c);
			    }	
				
			    x++;
			    if (x > 78 - rm)
			    {
				y++;
				if (y == 22 - bm)
				{
				    z++;
				    y = 21 - bm;
				}
				x = lm + 1;
			    }	    
		}
		ref_sub(sub);
		disp(win);
	}
}

void list :: arrow_up()
{
    int j;
    upa();
    if (x1 > 78 - rm - lm)
	x1 -= 78 - lm - rm;
    else
    {
	k--;
	int i = checkc(k);
	j = i;
	while (i > 78 - lm - rm)
	    i = i - (78 - lm - rm);
	x = x > i + lm ? i + lm : x;
	if (x <= lm)	x = lm + 1;
	if (j > 78 - lm - rm)	
	{
	    x1 = j;
	    i = i + lm - x;
	    x1 = x1 - i;
	}
	else x1 = x - lm;
    }
    
    node*   p = find(k,x1);
    while(p -> data == '\v' )
    {
	p = p -> prev;
	x--;
	if (x <= lm)	
	{
	    x = 78 - rm;
	    y--;
	    if (y <= tm)
	    {
		y = tm + 1;
		z--;
	    }
	}
	x1--;
    }
}	    

void list :: arrow_down()
{
    
}	    

void list :: arrow_left()
{
    
}

void list :: arrow_right()
{
    
}

void list :: upa()
{
}

void list :: dwna()
{
    
}

void list :: delc(int x,int y)
{
    
    
}

void list :: dell()
{
    
}

void list :: ad_delc(int k,int x1,int y)
{
    
}

void list :: home()
{
    
}

void list :: begin()
{
    
}	    

void list :: enda()
{
    
}

void list :: endp()
{
    while(k < end -> row)
	arrow_down();
    while(x1 < checkc(k))	arrow_right();
}

void list :: d_lin()
{
    if (head -> next == NULL)	beep();
    else
    {
	save = 0;
	dell();
    }
}

void list :: fsave(WINDOW *main)
{
    FILE *fp;
    WINDOW *ws;
    node *p,*q;
    int c;
    save = 1;
    ws = subwin(main,1,80,24,0);
    werase(ws);    
    init_pair(1,COLOR_WHITE,COLOR_BLACK);	
    wbkgd(ws,COLOR_PAIR(1) | A_BOLD);
    
    if (!strcmp(name,"noname"))
    {
	mvwaddstr(ws,0,10,"Enter the file name : ");
	wrefresh(ws);
	echo();
	wgetstr(ws,name);	
	noecho();
    }
    
    fp = fopen(name,"w+");
    
    for (p = head;p != NULL;p = p -> down)
	for (q = p -> next;q != NULL;q = q -> next)
	{
	    putc(q -> data,fp);
	    if (q -> data == '\t')	
		for (int i = 0;i < 4;i++)	q = q -> next;
	}
    fclose(fp);
}

void list :: nsave(WINDOW *main)
{
    WINDOW *ws;
    node *p,*q;
    int c;
    
    ws = subwin(main,1,80,24,0);
    werase(ws);
    init_pair(1,COLOR_WHITE,COLOR_BLACK);	
    wbkgd(ws,COLOR_PAIR(1) | A_BOLD);

    mvwaddstr(ws,0,10,"File ");
    waddstr(ws,name);
    waddstr (ws," not saved. Save (y or n) ?  : ");
    wrefresh(ws);
    
    c = wgetch(ws);
    
    if (c == 'y')	fsave(main);
}

WINDOW* list :: mainc(WINDOW *main)
{
    WINDOW *win;
    win = subwin(main,23,80,1,0);
    init_pair(2,COLOR_WHITE,COLOR_BLUE);	
    wbkgd(win,COLOR_PAIR(2));
    keypad(win,TRUE);
    box(win,0,0);
    return win;
}

WINDOW * list :: init_main(WINDOW *main)
{
    WINDOW *menu,*bmen;
    
    main = newwin(0,0,0,0);
    werase(main);
    init_pair(3,COLOR_WHITE,COLOR_BLUE);	
    wbkgd(main,COLOR_PAIR(3) | ACS_BOARD);
    keypad(main,TRUE);
    keypad(stdscr,TRUE);

    
    menu = subwin(main,1,0,0,0);
    init_pair(4,COLOR_BLACK,COLOR_CYAN);
    init_pair(10,COLOR_BLACK,COLOR_YELLOW);
    wbkgd(menu,COLOR_PAIR(4));
    mvwaddstr(menu,0,8,"FILE");
    mvwchgat(menu,0,8,1,A_REVERSE|A_BOLD,10,0);
    mvwaddstr(menu,0,28,"EDIT");
    mvwchgat(menu,0,28,1,A_REVERSE|A_BOLD,10,0);
    mvwaddstr(menu,0,48,"PAGE");
    mvwchgat(menu,0,48,1,A_REVERSE|A_BOLD,10,0);
    mvwaddstr(menu,0,68,"HELP");
    mvwchgat(menu,0,68,1,A_REVERSE|A_BOLD,10,0);
    wrefresh(menu);

    bmen = subwin(main,1,80,24,0);
    init_pair(4,COLOR_BLACK,COLOR_CYAN);
    wbkgd(bmen,COLOR_PAIR(4));
    mvwaddstr(bmen,0,5,"HELP-----");
    mvwaddstr(bmen,0,15,"F1");
    mvwchgat(bmen,0,15,2,A_REVERSE|A_BOLD,10,0);

    mvwaddstr(bmen,0,30,"MENU-----");
    mvwaddstr(bmen,0,40,"ALT_F");
    mvwchgat(bmen,0,40,5,A_REVERSE|A_BOLD,10,0);

    return main;
}

void list :: ref_sub(WINDOW *sub)
{
    char a,b;
    werase(sub);
    
    init_pair(1,COLOR_BLACK,COLOR_CYAN);
    wbkgd(sub,COLOR_PAIR(1));
    
    if (!(!(strcmp(name,"noname"))))
	mvwprintw(sub,0,1,"File name : %s",name);
    
    a = save ? 'Y' : 'N';
    b = ins ? 'Y' : 'N';
    mvwprintw(sub,0,31,"SAVE = %c , INS = %c ",a,b);	
    mvwprintw(sub,0,51,"ROW = %d,COL = %d  x1 : %d",y + z - tm,x - lm,x1);
    
    wrefresh(sub);
}    	

void list :: main_win(WINDOW *main)
{
    int c,i;
    char cl[] = "clear";

    werase(main);
    main = init_main(main);
    wrefresh(main);
    curs_set(0);
    save = 1;
    
    while(1)
    {
	main = init_main(main);
	curs_set(0);
	c = wgetch(main);
	wrefresh(main);
	
	switch(c)
	{
	    case (KEY_F(3)) :
		open_win(main);
		break;

	    case (KEY_F(1)) :
		open_help(main);
		werase(main);
		main = init_main(main);
		break;
	
	    case (KEY_F(5)) :
	        del_file(main);
	        break;
    	
	    case CNTRL_N :
		strcpy(name,"noname");
		inwin(main);
		break;

	    case 27:
		c = wgetch(main);
		switch(c)
		{
		    case 'f' :
			i = open_file(main,0);
			while(1)
			{
			    main = init_main(main);
			    wrefresh(main);
			    if(i == 0)	break;
			    else if(i == 1)	i = open_file(main,0);
			    else if(i == 4)	i = help_menu(main,0);
			}
			break;
			
				    
		    case 'h' :
			i = help_menu(main,0);
			while(1)
			{
			    main = init_main(main);
			    wrefresh(main);
			    if(i == 0)	break;
			    else if(i == 1)	i = open_file(main,0);
			    else if(i == 4)	i = help_menu(main,0);
			}

			break;
				    			
		    case 'x' :
			endwin();
			system(cl);
			exit(0);
			break;
		}
		break;
	}

    }
}

void list :: open_win(WINDOW *main)
{
    WINDOW *ws;
    FILE *fp;
    char nam[20];
    
    ws = subwin(main,1,80,24,0);
    werase(ws);    
    init_pair(1,COLOR_WHITE,COLOR_BLACK);	
    wbkgd(ws,COLOR_PAIR(1) | A_BOLD);
    
    mvwaddstr(ws,0,10,"Enter the file to be opened : ");
    wrefresh(ws);
    echo();
    wgetstr(ws,nam);
    noecho();
        
    fp = fopen(nam,"r");
    if (fp != NULL)	
    {
        fclose(fp);
	strcpy(name,nam);
        inwin(main);	
    }
    else
    {
	werase(ws);
	mvwprintw(ws,0,10,"The file %s not found : ",nam);
	wrefresh(ws);
	wgetch(ws);
    }
}

void list :: open_help(WINDOW *main)
{
    WINDOW *ws;
    int c;
    
    curs_set(0);
    ws = subwin(main,23,80,1,0);
    werase(ws);    
    box(ws,0,0);
    init_pair(5,COLOR_RED,COLOR_WHITE);	
    init_pair(11,COLOR_WHITE,COLOR_BLUE);	
    wbkgd(ws,COLOR_PAIR(5));
    

    mvwaddstr(ws,1,5,"FUNCTIONS");
    mvwaddstr(ws,1,27,"HOT KEYS");
    mvwaddstr(ws,1,42,"FUNCTIONS");
    mvwaddstr(ws,1,68,"HOT KEYS");
    mvwchgat(ws,1,0,80,A_NORMAL|A_BOLD,4,NULL);
    for (int i = 1;i < 79;i++) mvwaddch(ws,2,i,'-');
    for (int i = 1;i < 22;i++)	mvwchgat(ws,i,38,1,ACS_VLINE,5,NULL);
    mvwaddstr(ws,3,1,"HELP");
    mvwaddstr(ws,3,30,"F1");
    
    mvwaddstr(ws,4,4,"FILE OPTIONS");
    mvwaddstr(ws,5,1,"SAVE FILE");
    mvwaddstr(ws,5,30,"F2");
    mvwaddstr(ws,6,1,"OPEN FILE");
    mvwaddstr(ws,6,30,"F3");
    mvwaddstr(ws,7,1,"CLOSE FILE");
    mvwaddstr(ws,7,30,"F4");
    mvwaddstr(ws,8,1,"DELETE FILE");
    mvwaddstr(ws,8,30,"F5");
    mvwaddstr(ws,9,1,"NEW FILE");
    mvwaddstr(ws,9,30,"CNTRL_N");
    mvwaddstr(ws,10,1,"EXIT EDITOR");
    mvwaddstr(ws,10,30,"ALT_X");
    
    mvwaddstr(ws,12,4,"MENU OPTIONS");
    mvwaddstr(ws,13,1,"FILE");
    mvwaddstr(ws,13,30,"ALT_F");
    mvwaddstr(ws,14,1,"EDIT");
    mvwaddstr(ws,14,30,"ALT_E");
    mvwaddstr(ws,15,1,"PAGE");
    mvwaddstr(ws,15,30,"ALT_P");
    mvwaddstr(ws,16,1,"HELP");
    mvwaddstr(ws,16,30,"ALT_H");

    mvwaddstr(ws,4,45,"EDIT OPTIONS");
    mvwaddstr(ws,5,40,"INSERT WORD");
    mvwaddstr(ws,5,70,"CNTRL_A");
    mvwaddstr(ws,6,40,"INSERT LINE");
    mvwaddstr(ws,6,70,"CNTRL_L");
    mvwaddstr(ws,7,40,"DELETE WORD");
    mvwaddstr(ws,7,70,"CNTRL_W");
    mvwaddstr(ws,8,40,"DELETE LINE");
    mvwaddstr(ws,8,70,"CNTRL_Y");
    mvwaddstr(ws,9,40,"BEGIN");
    mvwaddstr(ws,9,70,"CNTRL_B");
    mvwaddstr(ws,10,40,"END");
    mvwaddstr(ws,10,70,"CNTRL_E");

    mvwaddstr(ws,12,45,"PAGE OPTIONS");
    mvwaddstr(ws,13,40,"FORE GROUND COLOR");
    mvwaddstr(ws,13,70,"F7");
    mvwaddstr(ws,14,40,"BACK GROUND COLOR");
    mvwaddstr(ws,14,70,"F8");
    mvwaddstr(ws,15,40,"SET LEFT MARGIN");
    mvwaddstr(ws,15,70,"F9");
    mvwaddstr(ws,16,40,"SET RIGHT MARGIN");
    mvwaddstr(ws,16,70,"F10");
    mvwaddstr(ws,17,40,"SET TOP MARGIN");
    mvwaddstr(ws,17,70,"F11");
    mvwaddstr(ws,18,40,"SET BOTTOM MARGIN");
    mvwaddstr(ws,18,70,"F12");

    wbkgd(ws,COLOR_PAIR(5));
    box(ws,0,0);
    mvwaddstr(ws,0,34,"HELP FILE");
    mvwchgat(ws,0,34,9,A_NORMAL|A_BOLD,11,NULL);
    mvwchgat(ws,4,1,20,A_NORMAL|A_BOLD,11,NULL);
    mvwchgat(ws,12,1,20,A_NORMAL|A_BOLD,11,NULL);
    mvwchgat(ws,4,40,20,A_NORMAL|A_BOLD,11,NULL);
    mvwchgat(ws,12,40,20,A_NORMAL|A_BOLD,11,NULL);
    wrefresh(ws);
    
    c = wgetch(ws);

    return;
}

int list :: open_file(WINDOW *main,int pl)
{
    WINDOW *ws;
    int c;
    char cl[] = "clear";
    char st[20][50] ={" NEW FILE       ^N"," OPEN FILE      F3"," SAVE FILE      F2"," SAVE AS"," CLOSE FILE     F4",
    " DELETE FILE    F5"," EXIT        ALT_X"};
    
    ws = subwin(main,15,20,1,0);
    werase(ws);
    box(ws,0,0);    
    init_pair(6,COLOR_BLACK,COLOR_CYAN);	
    wbkgd(ws,COLOR_PAIR(6));
    
    mvwaddstr(ws,1,2,"NEW FILE       ^N");
    mvwaddstr(ws,2,1,"------------------");

    mvwaddstr(ws,3,2,"OPEN FILE     F3");
    mvwaddstr(ws,4,1,"------------------");

    mvwaddstr(ws,5,2,"SAVE FILE      F2");
    mvwaddstr(ws,6,1,"------------------");
    
    mvwaddstr(ws,7,2,"SAVE AS");
    mvwaddstr(ws,8,1,"------------------");

    mvwaddstr(ws,9,2,"CLOSE FILE     F4");
    mvwaddstr(ws,10,1,"------------------");
    
    mvwaddstr(ws,11,2,"DELETE FILE    F5");
    mvwaddstr(ws,12,1,"------------------");
    
    mvwaddstr(ws,13,2,"EXIT        ALT_X");
    
    keypad(ws,TRUE);
    wmove(ws,1,1);
    wrefresh(ws);
    int a = 1,b = 1;
    curs_set(0);
    
    if(pl == 1)
    {
    while(1)
    {
	wmove(ws,a,b);
	blockwin(ws,st,a,13);
	c = wgetch(ws);
	wrefresh(ws);
		
	switch(c)
	{
	    case (KEY_RIGHT) :
		return 2;
	
	    case (KEY_LEFT) :
		return 4;
		
	    case (KEY_UP):
		if (a == 1)	a = 13;
		else 
	    	    a = a - 2;
		break;

	    case (KEY_DOWN):
		if (a == 13)	a = 1;
		else a = a + 2;
		break;
    
	    case 10 :
		curs_set(1);
		if (a == 1)   
		{
		    if (save == 0)
			nsave(main);

		    strcpy(name,"noname");
		    inwin(main);
		}
		else if (a == 3) 
		{
		    if(save == 0)
			nsave(main);
		    open_win(main);
		}
		else if (a == 5) fsave(main);
		else if (a == 7) 
		{
		    strcpy(name,"noname");
		    fsave(main);
		}
		else if (a == 9) 
		{
		    if(save == 0)
			nsave(main);
			
		    strcpy(name,"noname");
		    main_win(main);
		}
		else if(a == 11)
		    del_file(main);
		else if (a == 13) 
		{
		    if (save == 0)
			nsave(main);
			
		    system(cl);	
		    endwin();    
		    exit(0);
		}

		return 0;
				
	    case 27:	
		curs_set(1);
		wclear(ws);
		return 0;
	}
    }
    }
    else
    {
    while(1)
    {
	wmove(ws,a,b);
	blockwin(ws,st,a,13);
	c = wgetch(ws);
	wrefresh(ws);
		
	switch(c)
	{
	    case (KEY_RIGHT) :
	    case (KEY_LEFT) :
		return 4;
		
	    case (KEY_UP):
		if (a == 1)	a = 13;
		else if(a == 11) a = 3;
		else
	    	    a = a - 2;
		break;

	    case (KEY_DOWN):
		if (a == 13)	a = 1;
		else if (a == 3) a = 11;
		else a = a + 2;
		break;
    
	    case 10 :
		curs_set(1);
		if (a == 1)   
		{
		    strcpy(name,"noname");
		    inwin(main);
		}
		else if (a == 3) 
		    open_win(main);
		else if(a == 11)
		    del_file(main);
		else if (a == 13) 
		{			
		    system(cl);	
		    endwin();    
		    exit(0);
		}

		return 0;
				
	    case 27:	
		curs_set(1);
		wclear(ws);
		return 0;
	}
    }
    }
}

int list :: open_edit(WINDOW *main)
{
    WINDOW *ws;
    int c;
    char cl[] = "clear";
    char st[20][50] = {" INSERT WORD    ^A"," INSERT LINE    ^L"," DELETE WORD    ^W"," DELETE LINE    ^Y"};
        
    ws = subwin(main,9,20,1,20);
    werase(ws);
    box(ws,0,0);    
    init_pair(6,COLOR_BLACK,COLOR_CYAN);	
    wbkgd(ws,COLOR_PAIR(6));
    
    mvwaddstr(ws,1,2,"INSERT WORD    ^A");
    mvwaddstr(ws,2,1,"------------------");

    mvwaddstr(ws,3,2,"INSERT LINE    ^L");
    mvwaddstr(ws,4,1,"------------------");

    mvwaddstr(ws,5,2,"DELETE WORD    ^W");
    mvwaddstr(ws,6,1,"------------------");
    
    mvwaddstr(ws,7,2,"DELETE LINE    ^Y");

    keypad(ws,TRUE);
    wmove(ws,1,1);
    wrefresh(ws);
    int a = 1,b = 1;
    curs_set(0);
    
    while(1)
    {
	wmove(ws,a,b);
	blockwin(ws,st,a,7);
	c = wgetch(ws);
	wrefresh(ws);
		
	switch(c)
	{
	    case (KEY_RIGHT) :
		return 3;
	
	    case (KEY_LEFT) :
		return 1;
		
	    case (KEY_UP):
		if (a == 1)	a = 7;
		else
	    	    a = a - 2;
		break;

	    case (KEY_DOWN):
		if (a == 7)	a = 1;
		else a = a + 2;
		break;
    
	    case 10 :
		curs_set(1);
		if (a == 1)   word_in(main);
		else if (a == 3) line_in(main);
		else if (a == 5) 
		{
		    save = 0;
		    d_word();
		}
		else if (a == 7) 
		{
		    save = 0;
		    d_lin();
		}
		return 0;
				
	    case 27:	
		curs_set(1);
		return 0;
	}
    }
}

int list :: open_page(WINDOW *main)
{
    WINDOW *ws;
    int c;
    char cl[] = "clear";
    char st[20][50] = {" TOP MARGIN    F11"," BOTTOM MARGIN F12"," LEFT MARGIN    F9"," RIGHT MARGIN  F10"};
        
    ws = subwin(main,9,20,1,40);
    werase(ws);
    box(ws,0,0);    
    init_pair(6,COLOR_BLACK,COLOR_CYAN);	
    wbkgd(ws,COLOR_PAIR(6));
    
    mvwaddstr(ws,1,2,"TOP MARGIN    F11");
    mvwaddstr(ws,2,1,"------------------");

    mvwaddstr(ws,3,2,"BOTTOM MARGIN F12");
    mvwaddstr(ws,4,1,"------------------");

    mvwaddstr(ws,5,2,"LEFT MARGIN    F9");
    mvwaddstr(ws,6,1,"------------------");
    
    mvwaddstr(ws,7,2,"RIGHT MARGIN  F10");

    keypad(ws,TRUE);
    wmove(ws,1,1);
    wrefresh(ws);
    int a = 1,b = 1;
    curs_set(0);
    
    while(1)
    {
	wmove(ws,a,b);
	blockwin(ws,st,a,7);
	c = wgetch(ws);
	wrefresh(ws);
		
	switch(c)
	{
	    case (KEY_RIGHT) :
		return 4;
	
	    case (KEY_LEFT) :
		return 2;
		
	    case (KEY_UP):
		if (a == 1)	a = 7;
		else
	    	    a = a - 2;
		break;

	    case (KEY_DOWN):
		if (a == 7)	a = 1;
		else a = a + 2;
		break;
    
	    case 10 :
		curs_set(1);
		if (a == 1)   
		    topm(main);
		else if (a == 3) botm(main);
		else if (a == 5) 
		    leftm(main);
		else if (a == 7) 
		    rightm(main);
		return 0;
				
	    case 27:	
		curs_set(1);
		return 0;
	}
    }
}

int list :: help_menu(WINDOW *main,int pl)
{
    WINDOW *ws;
    int c;
    char cl[] = "clear";
    char st[20][50] = {" HELP           F1"," ABOUT"};
        
    ws = subwin(main,5,20,1,60);
    werase(ws);
    box(ws,0,0);    
    init_pair(6,COLOR_BLACK,COLOR_CYAN);	
    wbkgd(ws,COLOR_PAIR(6));
    
    mvwaddstr(ws,1,2,"HELP           F1");
    mvwaddstr(ws,2,1,"------------------");

    mvwaddstr(ws,3,2,"ABOUT");

    keypad(ws,TRUE);
    wmove(ws,1,1);
    wrefresh(ws);
    int a = 1,b = 1;
    curs_set(0);
    
    while(1)
    {
	wmove(ws,a,b);
	blockwin(ws,st,a,3);
	c = wgetch(ws);
	wrefresh(ws);
		
	switch(c)
	{
	    case (KEY_RIGHT) :
		return 1;
	
	    case (KEY_LEFT) :
		if (pl == 1)	return 3;
		else return 1;
		
	    case (KEY_UP):
		if (a == 1)	a = 3;
		else
	    	    a = a - 2;
		break;

	    case (KEY_DOWN):
		if (a == 3)	a = 1;
		else a = a + 2;
		break;
    
	    case 10 :
		curs_set(1);
		if (a == 1)   open_help(main);
		else if (a == 3) open_about(main);
		return 0;
				
	    case 27:	
		curs_set(1);
		return 0;
	}
    }
}

void list :: forcolor(WINDOW *win)
{
    fore++;
    init_pair(7,colour[fore],colour[bac]);
    wbkgd(win,COLOR_PAIR(7));

    if (fore == 8)
	fore = 0;
}

void list :: backcolor(WINDOW *win)
{
    bac++;
    init_pair(8,colour[fore],colour[bac]);
    wbkgd(win,COLOR_PAIR(8));

    if (bac == 8)
	bac = 0;
}

void list :: leftm(WINDOW *main)
{
    WINDOW *ws;
    node *p,*q;
    int c;
    char *f;
    
    begin();
    ws = subwin(main,1,80,24,0);
    werase(ws);
    init_pair(1,COLOR_YELLOW,COLOR_YELLOW);	
    wbkgd(ws,COLOR_PAIR(1) | A_BOLD);

    mvwprintw(ws,0,0,"The present value of left margin is %d.",lm);
    wprintw(ws," Enter the new value (MAX : %d) : ",78 - rm - 1);
    wrefresh(ws);
    wmove(ws,0,74);
    
    while(1)
    {
	echo();
	wscanw(ws,"%d",&c);
	noecho();
	if (c + 1 <= 78 - rm) break;
	wmove(ws,0,75);
	beep();
    }
    lm = c;
    x = lm + 1;
}

void list :: rightm(WINDOW *main)
{
    WINDOW *ws;
    node *p,*q;
    int c;
    char *f;
    
    begin();
    ws = subwin(main,1,80,24,0);
    werase(ws);
    init_pair(1,COLOR_YELLOW,COLOR_YELLOW);	
    wbkgd(ws,COLOR_PAIR(1) | A_BOLD);

    mvwprintw(ws,0,0,"The present value of right margin is %d.",rm);
    wprintw(ws," Enter the new value (MAX : %d) : ",78 - lm - 1);
    wrefresh(ws);
    wmove(ws,0,75);
    
    while(1)
    {
	echo();
	wscanw(ws,"%d",&c);
	noecho();
	if (78 - c >= lm + 1) break;
	wmove(ws,0,75);
	beep();
    }
    rm = c;
}

void list :: topm(WINDOW *main)
{
    WINDOW *ws;
    node *p,*q;
    int c;
    char *f;
    
    begin();
    ws = subwin(main,1,80,24,0);
    werase(ws);
    init_pair(1,COLOR_YELLOW,COLOR_YELLOW);	
    wbkgd(ws,COLOR_PAIR(1) | A_BOLD);

    mvwprintw(ws,0,0,"The present value of top margin is %d.",tm);
    wprintw(ws," Enter the new value (MAX : %d) : ",21 - bm);
    wrefresh(ws);
    wmove(ws,0,75);
    
    while(1)
    {
	echo();
	wscanw(ws,"%d",&c);
	noecho();
	if (c + 1 <= 21 - bm) break;
	wmove(ws,0,75);
	beep();
    }
    tm = c;
    y = tm + 1;
}

void list :: botm(WINDOW *main)
{
    WINDOW *ws;
    node *p,*q;
    int c;
    char *f;
    
    begin();
    ws = subwin(main,1,80,24,0);
    werase(ws);
    init_pair(1,COLOR_YELLOW,COLOR_YELLOW);	
    wbkgd(ws,COLOR_PAIR(1) | A_BOLD);

    mvwprintw(ws,0,0,"The present value of bottom margin is %d.",bm);
    wprintw(ws," Enter the new value (MAX : %d) : ",21 - tm - 1);
    wrefresh(ws);
    wmove(ws,0,75);
    
    while(1)
    {
	echo();
	wscanw(ws,"%d",&c);
	noecho();
	if (21 - c >= tm + 1) break;
	wmove(ws,0,75);
	beep();
    }
    bm = c;
}

void list :: blockwin(WINDOW *ws,char st[20][50],int a,int n)
{
    int i;
    
    for(i = 1;i <= n;i += 2)
    {
	if (i == a)
	{
	    wattron(ws,A_REVERSE | A_BOLD);
	    waddstr(ws,st[a/2]);
	    wattroff(ws,A_REVERSE | A_BOLD);
	}
	else 
	{
	    wattroff(ws,A_REVERSE | A_BOLD);
	    wmove(ws,i,1);
	    waddstr(ws,st[i/2]);
	    wmove(ws,a,1);
	}
    }
    wrefresh(ws);
}

void list :: del_file(WINDOW *main)
{
    WINDOW *ws;
    FILE *fp;
    char nam[20],del[20] = "rm -f ";
    
    ws = subwin(main,1,80,24,0);
    werase(ws);    
    init_pair(1,COLOR_WHITE,COLOR_BLACK);	
    wbkgd(ws,COLOR_PAIR(1) | A_BOLD);
    
    mvwaddstr(ws,0,10,"Enter the file to be deleted : ");
    wrefresh(ws);
    echo();
    wgetstr(ws,nam);
    noecho();
        
    strcat(del,nam);
    
    fp = fopen(nam,"r");
    if (fp != NULL)	
    {
        fclose(fp);
	system(del);
	if (!(strcmp(nam,name)))
	{
	    strcpy(name,"noname");
	    main_win(main);
	}
    }
    else
    {
	werase(ws);
	mvwprintw(ws,0,10,"The file %s not found : ",nam);
	wrefresh(ws);
	wgetch(ws);
    }
}

void list :: open_about(WINDOW *main)
{
    WINDOW *ws;
    
    ws = subwin(main,10,30,4,20);
    werase(ws);
    init_pair(9,COLOR_RED,COLOR_WHITE);	
    init_pair(10,COLOR_WHITE,COLOR_BLACK);
            
    box(ws,0,0);
    wbkgd(ws,COLOR_PAIR(9));
    mvwaddstr(ws,0,12,"About");
    mvwchgat(ws,0,12,5,A_REVERSE,10,NULL);
    curs_set(0);
    wrefresh(ws);
    
    int c = wgetch(ws);
}

main(int argc,char *argv[])
{
    WINDOW *main;
    list scr;
    
    initscr();
    noecho();
    cbreak();
    start_color();
    raw();
    curs_set(0);
    
    main = scr.init_main(main);
    
    if (argc <= 1)	scr.main_win(main);
    else
    {
	strcpy(name,argv[1]);
        scr.inwin(main);
    }
    
    endwin();
        
    return 0;
}
